/*
 * SupplierClientsView.java
 *
 * Created on 10 de agosto de 2004, 18:11
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import java.util.Vector;

import com.fenalco.entities.ShopKeeperList;
import com.fenalco.entities.User;
import com.fenalco.entities.DataAccess;
import com.fenalco.entities.Province;
import com.fenalco.entities.City;

import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.ShopKeeperListViewSupplier;

/**
 * Este servlet construye el listado de los clientes del proveedor, es decir los
 * minoristas con los que tiene una relación comercial establecida a través de
 * la aceptación de entrega en uno o varios establecimientos.
 * 
 * @author andres
 */
public class SupplierClientsView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Construye un objeto ShopKeeperList pasando como parámetro el
	 * identificador de proveedor. Este objeto contiene la información que
	 * requiere <CODE>clientesproveedor.jsp</CODE>
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
	
                               // criterios de paginación
				int pagina = 1;
				int resultadosPagina = 20;
				int paginas; // numero total de páginas
				int inicio = 0; // numero del primero registro que se va a mostrar
				int fin = 9; // numero del último registro que se va a mostrar
				int total; // numero total de resultados
                                
                                String temp = request.getParameter("page");
                                if( temp == null ){
                                    
                                    pagina = 1;
                                    
                                }else{
                                
                                    pagina = Integer.parseInt( temp );
                                    
                                }
                                
                                pagina = (pagina < 1)? 1 : pagina;
                                temp = request.getParameter( "pageResults" );
                                
                                if( temp == null ){
                                    
                                    resultadosPagina = 20;
                                    
                                }else{
                                
                                    resultadosPagina = Integer.parseInt( temp );
                                    
                                }
                                
                                resultadosPagina = (resultadosPagina < 1)? 20 : resultadosPagina;
                                
                                int countryId = 1; //Se fija en Colombia
                                int provinceId = -1;
                                int cityId = -1;
                                
                                Vector provinces = new Vector();
                                Vector cities = new Vector();
                                String t1 = request.getParameter("province");
                                String t2 = request.getParameter("city");
                                String clicked = request.getParameter("clicked");
                                
                                                               
                                if( t1 != null && t2 != null && clicked != null ){
                                
                                    provinceId = Integer.parseInt( t1 );
                                    cities = DataAccess.getCities( provinceId );
                                    
                                    if( clicked.equals("0") ){
                                        if( provinceId != -1 ){
                                            cityId = ( (City)cities.elementAt(0) ).getId();
                                        }
                                    }else{
                                        cityId = Integer.parseInt( t2 );
                                    }
                                    
                                                                                                          
                                }else{
                                    
                                    
                                    provinces = DataAccess.getValidProvinces( countryId );
                                    if( provinces.size() > 0 ){
                                        provinceId = ( ( Province ) provinces.elementAt( 0 ) ).getId();
                                    }
                                    cities = DataAccess.getCities( provinceId );
                                    cityId = ( (City)cities.elementAt(0) ).getId();
                                     
                                }
                                
                                //System.out.println( "pId: "+ provinceId + " cId: " + cityId );
                                                                
				//Adición de ciudades
                                provinces = DataAccess.getValidProvinces( countryId );
                                if( provinceId != -1 ){
                                    cities = DataAccess.getCities( provinceId );
                                }
                                
                                User supplier = (User) session.getAttribute("user");
                                
                                String shopKeeperName = request.getParameter( "shopKeeperName" );
                                if( shopKeeperName == null ){
                                    shopKeeperName="";
                                }
                                ShopKeeperList shopKeeperList = new ShopKeeperList( supplier.getCompanyId(), shopKeeperName );
                                shopKeeperList.filterByProvince( provinceId );
                                shopKeeperList.filterByCity( cityId );
                                                                
                                
                                Vector results = new Vector();
                                total = shopKeeperList.getShopKeepers().size();
                                
                                paginas = (int) Math.ceil((double) total / (double) resultadosPagina);
                                
				if( pagina > paginas ){
					pagina = paginas;
				}
                                
				inicio = (pagina - 1) * resultadosPagina;
				fin = pagina * resultadosPagina;
				inicio = (inicio < 0) ? 0 : inicio;
                                
				if( fin > total ){
					fin = total;
				}
                                
				for( int i = inicio; i < fin; i++ ){
					results.addElement( shopKeeperList.getShopKeepers().elementAt(i) );
                                }
                                
                                shopKeeperList.setShopKeepers( results );
                                
				ShopKeeperListViewSupplier view = new ShopKeeperListViewSupplier( shopKeeperList, supplier.getCompanyId() );
	
				if( view == null )
				{
					//Fallo en la creación de la lista de clientes
					//message = "Fallo en la creación de la lista de clientes";
					message = MessageBuilder.buildMessage(9);
					url = "/proveedor/clientesproveedor.jsp";
                                        
                                        
				}
				else
				{
					//Todo OK
					//message = "La lista de clientes se creó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					url = "/proveedor/clientesproveedor.jsp";
	
					request.setAttribute("view", view);
                                        request.setAttribute("provinces", provinces);
                                        request.setAttribute("provinceId", new Integer(provinceId));
                                        request.setAttribute("cities", cities);
                                        request.setAttribute("cityId", new Integer(cityId));
                                        
                                 }
                                
                                 /// información de la paginacion
                                 inicio++; // para no arrancar desde 0
                                 inicio = (fin == 0) ? 0 : inicio;
                                 request.setAttribute("firstRow", inicio + "");
				 request.setAttribute("lastRow", fin + "");
				 request.setAttribute("total", total + "");
				 request.setAttribute("page", pagina + "");
				 request.setAttribute("pages", paginas + "");
				 request.setAttribute("pageResults", resultadosPagina + "");
	
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}